/*

License $Id: MapAdapt.java,v 1.1 2001/05/06 14:55:02 Hendrik Exp $

Copyright (c) 2001 tagtraum industries.

The sixbs library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

For LGPL see <http://www.fsf.org/copyleft/lesser.txt>

We encourage your feedback and suggestions and want to use your feedback to
improve the Software. Send all such feedback to:
feedback@tagtraum.com

For more information on tagtraum industries, Hendrik Schreiber and sixbs
please see <http://www.tagtraum.com/>.

*/

package com.tagtraum.sixbs.adapters.util;

import com.tagtraum.sixbs.AbstractAdapter;
import com.tagtraum.sixbs.SIXBSException;

import java.util.Iterator;
import java.util.Map;

/**
 * Adapter for a {@link java.util.Map}.
 * 
 * @author 	Hendrik Schreiber
 * @version $Id: MapAdapt.java,v 1.1 2001/05/06 14:55:02 Hendrik Exp $
 */
public class MapAdapt extends AbstractAdapter {

    /**
     * Source-Version
     */
    public static String	vcid = 
	"$Id: MapAdapt.java,v 1.1 2001/05/06 14:55:02 Hendrik Exp $";
    
    private Map map;
    
    public MapAdapt(Map map) {
        this.map = map;
    }
    
    public MapEntry[] getMapEntries() {
        MapEntry[] entries = new MapEntry[map.size()];
        Iterator iterator = map.entrySet().iterator();
        for (int i=0; iterator.hasNext(); i++) {
            Map.Entry e = (Map.Entry)iterator.next();
            entries[i] = new MapEntry(e.getKey(), e.getValue());
        }
        return entries;
    }
    
    public void setMapEntries(MapEntry[] entries) {
        for (int i=0; i<entries.length; i++) {
            map.put(entries[i].getKey(), entries[i].getValue());
        }
    }

    public Object deserialize() throws SIXBSException {
        return map;
    }

    protected void setInternalMap(Map map) {
        this.map = map;
    }
}
